/* Copyright (c) 2012 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is property of Nordic Semiconductor ASA.
 * Terms and conditions of usage are described in detail in NORDIC
 * SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 */
 
#include <stdio.h>
#include <stdint.h>
#include "app_uart.h"
#include "nordic_common.h"

#include "nrf_gpio.h"
#include "boards.h"
#include "simple_uart.h"

struct __FILE { int handle; /* Add whatever you need here */ };
FILE __stdout;
FILE __stdin;

uint32_t retarget_init(void)
{
    nrf_gpio_cfg_output(TX_PIN_NUMBER);
    nrf_gpio_cfg_input(RX_PIN_NUMBER, NRF_GPIO_PIN_NOPULL);
    
    NRF_UART0->PSELRXD = RX_PIN_NUMBER;
    NRF_UART0->PSELTXD = TX_PIN_NUMBER;
    
    if (HWFC)
    {
        NRF_UART0->CONFIG = UART_CONFIG_HWFC_Enabled << UART_CONFIG_HWFC_Pos;
        
        nrf_gpio_cfg_output(RTS_PIN_NUMBER);
        nrf_gpio_cfg_input(CTS_PIN_NUMBER, NRF_GPIO_PIN_NOPULL);
        
        NRF_UART0->PSELCTS = CTS_PIN_NUMBER;
        NRF_UART0->PSELRTS = RTS_PIN_NUMBER;
    }
    
    NRF_UART0->BAUDRATE = UART_BAUDRATE_BAUDRATE_Baud38400;
    NRF_UART0->ENABLE = UART_ENABLE_ENABLE_Enabled << UART_ENABLE_ENABLE_Pos;
    NRF_UART0->TASKS_STARTTX = 1;
    
    return NRF_SUCCESS;
}

int fputc(int ch, FILE * p_file) 
{
    NRF_UART0->TXD = ch;
    while(!NRF_UART0->EVENTS_TXDRDY)
    {
    }
    NRF_UART0->EVENTS_TXDRDY = 0;
    return ch;
}

/**
 *@}
 **/
 
